# Lua / StarfallEx [![License](https://img.shields.io/github/license/Vurv78/Autorun-rs?color=red)](https://opensource.org/licenses/Apache-2.0) [![github/Vurv78](https://img.shields.io/discord/824727565948157963?label=Discord&logo=discord&logoColor=ffffff&labelColor=7289DA&color=2c2f33)](https://discord.gg/epJFC6cNsw)

> A collection of lua code and or sf chips and libraries.  
[Find Starfall Here](https://github.com/thegrb93/StarfallEx)

## Jit/Lua Libraries
* Detours > Basic detour library based off of msdetours that powers projects like [Safety](https://github.com/Vurv78/Safety)
## Starfall Libraries
* Async > Async library. Write asynchronous functions and await them using custom metatable syntax.
* GLua Compat > Compatibility with a small amount of glua functions. Unfinished 🚧.
* Simple UI > Simple Render UI Library
* PNGWriting > Create PNG files and write their pixels. Supports RGB+A
* StructReader > Struct Reader useful for interpreting tables from net messages or files
* A* > A* Pathfinding ported to SF
* 2D Perlin Noise > 2D Perlin Noise library ported to SF
* Net Streams > Alternative to the net.writeStream function
## Starfall Projects
* ClientSync > Use Clientside functions such as ``file.write`` on the ``SERVER`` realm.
* Map Texture Downloader > Download every texture on the map as a PNG or compressed text file
* Raytracer Framework > Framework to create raytracers
